Windows/Binary:
===============
Call setup*.exe to start graphical installer

Windows/Source:
===============
Open the *.dsw-file in Visual Studio 6, compile and start from the
WIN32/Build directory

Windows/Source/Cygwin
=====================
If you do not want to buy M$ Visual Studio, it is also possible to 
build it in Cygwin, please follow the (generic) Unix-Instructions below. 

You will also need to compile SDL from source, it is not part 
of the official cygwin-distribution now. You can find additional cygwin-ports
(which include the SDL-libraries!) on: http://cygwinports.dotsrc.org/.

If you do not have installed all the sound libraries, you can disable sound
in globals.h.

If you compiled in cygwin, you will recieve a binary which requires a X-Server, so be
sure that you install an X-server (it is included in cygwin) and start it (with 'startx')
before you start LostPixels.


MacOSX/Binary:
==============
Open the .dmg-Image and drag the LostPixels-Icon to the desired location.


MacOSX/Source:
==============
Open the XCode-Project in XCode2.2 (or higher) and compile. For debugging, open globals.h and change

#else // NO RELEASE
#define RESPATH "/Users/cavac/src/xcode/BlinkGame/LostPixels/build/Development/LostPixels.app/Contents/Resources/"
#endif // RELEASEMODE

to the path where you compiled to application to and Clean/Recompile everything.


Other Unix/Linux/... operating systems:
=======================================

The game does not have a GNU autoconf/automake based build system, but
compiling the source should be easy. There are two possibilities:

- a hand written Makefile (old)
- Building with cmake (new)



(OLD) hand written Make system:
===============================
tar xvzf LostPixels-VERSION.tar.gz
cd LostPixels-VERSION/lostpixels/game/software/
make
sudo make install

That will compile and install "LostPixels" in /usr/local/bin and the necessary 
data-files in /usr/local/share/blinkensisters. 
Documentation goes into /usr/local/share/doc/blinkensisters

You will (usually) need root-permissions, if you want to install to /usr/local/...
If you do not have root-permissions (or prefer another path for whatever 
reason), you can define a PREFIX Variable, e.g.

make PREFIX=$HOME
make install PREFIX=$HOME

will install LostPixels inside your homedirectory ($HOME/bin/LostPixels). 

To start the game, run the "LostPixels" executable. "LostPixels --help" will 
give you short introduction about the supported command line options.

You may need to edit the Makefile (e.g. if you compile on Unix-platform, 
where the GNU tools are not the standard-tools (I recommend using the GNU 
versions of the tools for building). 

You will need the following Libraries/(Packages for your distribution (including the
development-packages, if packaged seperately (which is often the case))

- A C++ compiler, for example GNU g++:  http://gcc.gnu.org/
- GNU Make:  http://www.gnu.org/software/make/
- libSDL (+ development packages (Headers, ...)): http://www.libsdl.org/
- libSDL_mixer (+ development packages): http://www.libsdl.org/projects/SDL_mixer/
  (that library is not required, if you disable sound (edit globals.h)).
- libSDL_image (+ development packages): http://www.libsdl.org/projects/SDL_image/
- libSDL_ttf (+ development packages): http://www.libsdl.org/projects/SDL_ttf/
- libSDL_net (+ development packages): http://www.libsdl.org/projects/SDL_net/
  (that library is not required, if you disable networking (edit globals.h)).
- For the generation of dependencies, the "makedepend" program is used, this is
  part of xutils (Debian), xorg-x11-devel (Suse), or x11-devel, xfree86-devel.

  Since makedepend caused some difficulties in the past, makedepend is now
  optional. By default it is not needed, but then full depdency tracking is 
  disabled. If you want to build using full dependency tracking, add "DEPENDENCIES=true"
  to the make command, e.g. "make DEPENDENCIES=true"
  Otherwise (especially if you change the source...) I recommend, that you always 
  do a "make clean" before a "make"

If you want a installation package, you can create the following packages 
automatically:

make rpm 
- will create a RPM Package on rpm based Linux distributions.
  "make rpm" will work only (on RPM-based systems, of course) if you have
  write permissions to /usr/src/rpm/* (usually only root) or you
  tell rpm to use a different build area, see
  http://www.rpm.org/max-rpm/s1-rpm-anywhere-different-build-area.html

make solaris-pkg
- will create a solaris package.



(NEW) BUILD WITH CMAKE
======================

Cmake is a rather new build system.

You will need cmake (http://www.cmake.org), the SDL-libraries mentioned above
and the usual Unix build tools (cc, make, ...)

# extract the sourcecode:
tar xvzf LostPixels-VERSION.tar.gz
# change to the cmake-build directory: cd cmake-build
cd LostPixels-VERSION/lostpixels/game/software/cmake-build
# (this is called a (recommended) out-of-source build). Run:
cmake .. # you will need at least cmake 2.4.4
# (if you want to build to another location than /usr/local, you can do a
# cmake .. -DCMAKE_INSTALL_PREFIX:PATH=/my/path
# if you want to change the compiler (for example) you can do
# CC=icc  CXX=icpc cmake ..  # use the Intel compiler  or
# CC=pgcc CXX=pgCC cmake ..  # use the PGI compiler
# then build the program with:
make   # or make VERBOSE=1
sudo make install # and then install it

The following Options are possible:
-DUSE_SDL_MIXER=NO  (default: YES) - disable sound
-DUSE_SDL_NET=NO    (default: YES) - disable networking
-DUSE_THEORA=YES    (default: NO)  - enable Ogg/Theora videos

e.g.
cmake .. -DUSE_SDL_MIXER=NO

Instead of a make clean, remove all files in the cmake-build directory.

If you want to build RPMs using cmake, you have the following make-targets:
make blinkensisters_rpm  # build the binary rpm
make blinkensisters_srpm # build the source rpm



We tested and successfully build it on the following Unices: 
 - Suse Linux (9.2, 9.3, 10.0, 10.1, 10.2, 10.3) 
 - Debian GNU/Linux 3.1
 - Solaris 8, 10
 - SGI IRIX
 - the Cygwin environment in Windows

If you have problems, when compiling the program, please check, if the 
required packages are installed - and if it does not work, please submit a bug
report and provide as much information as possible (the exact error message, 
details about the operating system / compiler / build-system / platform you use, ...).



CommandLine-Parameter
=====================

LostPixels --help
will give you a short help about the accepted (unix-style, even on windows) command-line options:

  -f, --fullscreen             Use Fullscreen (default)
  -w, --windowed               Use windowed mode
  -s, --disable-sound          Disable sound
  -v, --version                Print version information and exit
  -h, --help                   Command-line help
  -u, --update-basedata        Force update of basedata
  -p, --proxyurl               URL of the HTTP Proxy (--proxyurl=http://proxy.example.com:port or -p=http://proxy.example.com:port)


Enjoy our game.
